#include <psppower.h>

//#include "main.h"
#include "psp.h"
#include "blitter.h"
#include "pg.h"
#include "neocd.h"
#include "filer.h"
#include "sdl_gfx.h"

//#include "syscall.h"

#define TITLE_COL RGB(255,255,255)
#define PATH_COL RGB(255,255,255)

#define FILE_COL RGB((255-i*10/rows),(255-i*10/rows),0)

#define SEL_COL RGB(255,255,255)

extern int neogeo_region,neogeo_mp3_volume;
extern int MP3_pause,bLoop;
u32 new_pad,old_pad;


extern int neogeo_autofireA,neogeo_autofireB,neogeo_autofireC,neogeo_autofireD;
int exit_menu;
extern int neogeo_speedlimit,neogeo_showfps,neogeo_blitter,neo4all_z80_cycles_idx,neo4all_68k_cycles_idx,neogeo_hardrender;

extern int	neogeo_hreset(void);

int menu_reset(){

  int pad = ConfirmDlg("Reset NEOGEO ?");
  if (pad&PSP_CTRL_CIRCLE) {
    int height = get_font_height()+20+8;
    int y0 = 136-height/2+10;

    pgFillBoxHalfer(0,0,SCREEN_WIDTH,SCREEN_HEIGHT,80);
    pgFillBoxLinedV(0,136-height/2,480,136+height/2,50,1);
    pgPrintCenter_font(y0,RGB_WHITE,"Reseting...",0);
    pgPrintCenter_font(y0+get_font_height(),RGB_WHITE,"Please wait",0);
    pgScreenFlipV();
    neogeo_hreset();
    return 1;

  }
  return 0;
}

int menu_exitbrowser(){
	bLoop=0;
	return 1;
}

int menu_exit() {
  ExitCallback(1,2,NULL);
  return 0;
}

static int menu_active;

int show_osd_menu() {
  menu_active = 1;
  return 0;
}

int show_controls_menu() {
  menu_active = 2;
  return 0;
}

typedef struct {
		const char label[64];
		int (*menu_func)(void);
		int	*value_int;
		int	values_list_size;
		int values_list[16];
		char* values_list_label[16];
} menu_time_t;

// ADD_START
#define SEPARATOR "-----------"
// ADD_END

menu_time_t *psp_menu;

menu_time_t main_menu[]={
	{"Sound : ",NULL,&neogeo_sound_enable,2,{0,1},{"Off","On"}},
	{"MP3 volume % : ",NULL,&neogeo_mp3_volume,11,{0,10,20,30,40,50,60,70,80,90,100},{NULL}},
	{"Render : ",NULL,&neogeo_blitter,4,{0,1,2,3},{"1:1","Zoom1","Zoom2","Full"}},
	{"Frameskip : ",NULL,&neogeo_frameskip,7,{0,1,2,3,4,5,6},{"0","1","2","3","4","5","Auto"}},
	{SEPARATOR,NULL,NULL,0,{0},{NULL}},
	{"Controls...",show_controls_menu,NULL,0,{0},{NULL}},
	{"OSD...",show_osd_menu,NULL,0,{0},{NULL}},
	{SEPARATOR,NULL,NULL,0,{0},{NULL}},
	{"GFX Engine : ",NULL,&neogeo_hardrender,2,{0,1},{"Software","Hardware"}},
	{"Video sync : ",NULL,&psp_vsync,2,{0,1},{"Off","On"}},
	{"60fps limit : ",NULL,&neogeo_speedlimit,2,{0,1},{"Off","On"}},
	{SEPARATOR,NULL,NULL,0,{0},{NULL}},
	{"PSP clock : ",NULL,&psp_cpuclock,3,{222,266,333},{NULL}},
	{SEPARATOR,NULL,NULL,0,{0},{NULL}},
	{"NEOGEO Region : ",menu_reset,&neogeo_region,3,{0,1,2},{"Japan","USA","Europe"}},
	{"Reset NEOGEO",menu_reset,NULL,0,{0},{NULL}},
	{"Return to GAME browser",menu_exitbrowser,NULL,0,{0},{NULL}},
	{SEPARATOR,NULL,NULL,0,{0},{NULL}},
	{"Exit emulator",menu_exit,NULL,0,{0},{NULL}}
};

menu_time_t osd_menu[] = {
  {"Show FPS : ",NULL,&neogeo_showfps,3,{0,1,2},{"Off","Counter","Profiler"}},
  {"Show MP3 Track : ",NULL,&neogeo_mp3_trackname,2,{0,1},{"Off","On"}},
  {"Show MP3 errors : ",NULL,&neogeo_mp3_errors,2,{0,1},{"Off","On"}},
  {"Background : ",NULL,&osd_background,2,{0,1},{"Black","Transparent"}}
};

menu_time_t controls_menu[] = {
  {"Select lock: ",NULL,&select_lock,2,{0,1},{"Off","On"}},
  {"Autofire A : ",NULL,&neogeo_autofireA,4,{0,1,2,3},{"Off","Slow","Medium","Fast"}},
  {"Autofire B : ",NULL,&neogeo_autofireB,4,{0,1,2,3},{"Off","Slow","Medium","Fast"}},
  {"Autofire C : ",NULL,&neogeo_autofireC,4,{0,1,2,3},{"Off","Slow","Medium","Fast"}},
  {"Autofire D : ",NULL,&neogeo_autofireD,4,{0,1,2,3},{"Off","Slow","Medium","Fast"}},
};

#define MENU_ITEMS 19

int showmenu(void)
{
  int retval;
  unsigned long color=RGB_WHITE;
  // ADD_START
  int sel=0, rows=13, top=0, x, y, h, i, xmax=0, pad_cnt=5;
  // ADD_END

  /* DELETE_START
     static signed int sel=0, rows=25,top=0;
     int x, y, h, i,pad_cnt=5;
     DELETE_END */
  int old_mp3_pause;
  struct dirent *files = NULL;
  int disp_fonts = 0;
  int font_index = 0;
  int nfiles = 0,menu_items = 1,selmenu = 0,selfont = 0;
  char msg[80];
  char *title = "";

  load_default_font();
  old_mp3_pause=MP3_pause;

  MP3Pause(1);
  neogeo_soundmute=1;
  scePowerSetClockFrequency(222,222,111);
  pgScreenFrame(2,0);
  pgFillAllvram(0);

  old_pad=0;
  for(;;){
    /* DELETE_START
       show_background(192);
       pgDrawFrame(12,12,480-12,272-12,28|(28<<5)|(28<<10));
       pgDrawFrame(11,11,480-11,272-11,30|(30<<5)|(30<<10));
       DELETE_END */

    if (disp_fonts)
      rows = 21;
    else
      rows = 240/get_font_height();

    if (disp_fonts) {
      menu_items = nfiles;
      title = "";
    } else {
      switch(menu_active) {
      case 0: // default main menu
	psp_menu = main_menu;
	menu_items = MENU_ITEMS;
	title = "Main menu";
	break;
      case 1: // osd menu
	psp_menu = osd_menu;
	menu_items = 4;
	title = "OSD options";
	break;
      case 2:
	psp_menu = controls_menu;
	menu_items = 5;
	title = "Control options";
	break;
      }
    }

    new_pad=0;
    if (!pad_cnt) new_pad=get_pad();
    else pad_cnt--;
    pgWaitV();

    if (new_pad) {
      if (old_pad==new_pad) pad_cnt=2;
      else pad_cnt=5;
      old_pad=new_pad;
    }

    if((new_pad & PSP_CTRL_CIRCLE) && !disp_fonts){
      if (psp_menu[sel].menu_func)
	if ((*psp_menu[sel].menu_func)()) {retval=0;break;}
    } else if (new_pad & PSP_CTRL_TRIANGLE)
      menu_active = 0;
    else if(new_pad & PSP_CTRL_CROSS)   { retval=0;break; }
    // ADD_START
    else if(new_pad & PSP_CTRL_UP)      { sel--; if( !disp_fonts && strcmp ( psp_menu[sel].label, SEPARATOR ) == 0 ) sel-- /* skip separator */; }
    else if(new_pad & PSP_CTRL_DOWN)    { sel++; if( !disp_fonts && strcmp ( psp_menu[sel].label, SEPARATOR ) == 0 ) sel++ /* skip separator */; }
    else if (new_pad & PSP_CTRL_RTRIGGER) {
      disp_fonts = 1;
      selmenu = sel;
      sel = selfont;
      continue;
    } else if (new_pad & PSP_CTRL_LTRIGGER) {
      disp_fonts = 0;
      selfont = sel;
      sel = selmenu;
      continue;
    }

    // ADD_END
    /* DELETE_START
       else if(new_pad & PSP_CTRL_UP)      { sel--;    }
       else if(new_pad & PSP_CTRL_DOWN)    { sel++;    }
       DELETE_END */
    else if((new_pad & PSP_CTRL_LEFT) && !disp_fonts)    {
      if (psp_menu[sel].value_int){
	int cur=*(psp_menu[sel].value_int);
	for (i=1;i<psp_menu[sel].values_list_size;i++){
	  if (cur==psp_menu[sel].values_list[i]) {
	    *(psp_menu[sel].value_int)=psp_menu[sel].values_list[i-1];
	    break;
	  }
	}
      }
    }
    else if((new_pad & PSP_CTRL_RIGHT) && !disp_fonts)    {
      if (psp_menu[sel].value_int){
	int cur=*(psp_menu[sel].value_int);
	for (i=0;i<psp_menu[sel].values_list_size-1;i++){
	  if (cur==psp_menu[sel].values_list[i]) {
	    *(psp_menu[sel].value_int)=psp_menu[sel].values_list[i+1];
	    break;
	  }
	}
      }
    }
    // ADD_START
    else if ((new_pad & PSP_CTRL_SELECT) && (new_pad & PSP_CTRL_START)) {
      ExitCallback(1,2,NULL);
    }
    // ADD_END

    if(top > menu_items-rows)	top=menu_items-rows;
    if(top < 0)				top=0;
    if(sel >= menu_items)		sel=0;
    if(sel < 0)				sel=menu_items-1;
    if(sel >= top+rows)		top=sel-rows+1;
    if(sel < top)			top=sel;

    // ADD_START
    // sprintf(msg,"font size %d %d loaded %d",get_font_width(),get_font_height(),menu_items);

    if (menu_active)
      strcpy(msg,"\4:Back to main menu");
    else
      strcpy(msg,"\1:OK - \2:Return to game - \6,\b:Change Value - SELECT+START:Exit");
    menu_frame(title,msg,2+disp_fonts);

    x=4; y=17;

    font_index = 0;

    for(i=0; i<rows; i++){
      char *str;
      if (disp_fonts) {
	if (!files) {
	  int n;
	  files = getDir_fonts(tmp_str);
	  nfiles = get_nfiles();
	  for (n=0; n<nfiles; n++) {
	    if (!strcmp(default_font,files[n].name)) {
	      sel = selfont = n+1;
	      break;
	    }
	  }
	}

	if (top+i==0) { // 1st font = default font
	  // load_font("",0,0);
	  str = "Default GUI font";
	} else {
	  int width,height;
	  while (font_index < nfiles && !strcasestr(files[font_index].name,"fnt"))
	    font_index++;
	  if (font_index >= nfiles)
	    break;
	  get_font_dimensions(files[font_index].name,&width,&height);
	  // if (width && height)
	  // load_font(files[font_index].name,width,height);
	  sprintf(msg,"%s %dx%d",files[font_index].name,width,height);
	  str=msg;
	  font_index++;
	}
      } else {
	str = (char *)psp_menu[top+i].label;
      }
      if((top+i) >= menu_items) break;
      if((top+i) == sel) {
	color = SEL_COL;
	if (disp_fonts) {
	  if (strcmp(default_font,files[font_index-1].name)) { // changed
	    int width,height;
	    strcpy(default_font,files[font_index-1].name);
	    // I can't use load_default_font here because it's cached
	    get_font_dimensions(default_font,&width,&height);
	    load_font(default_font,width,height);
	  }
	}
      } else
	color = FILE_COL;
      if (color==SEL_COL) pgPrintSel_font(x, y, color, str,0,xmax);
      else if (disp_fonts)
	pgPrint(x, y, color, str,0);
      else
	pgPrint_font(x, y, color, str,0);

      if (!disp_fonts) {
	if (psp_menu[top+i].value_int) {
	  if (psp_menu[top+i].values_list_label[0]){
	    if (psp_menu[top+i].values_list_label[*(psp_menu[top+i].value_int)])
	      pgPrint_font(x+strwidth_font(psp_menu[top+i].label), y, color, psp_menu[top+i].values_list_label[*(psp_menu[top+i].value_int)],0);
	  } else pgPrintDecTrim_font(x+strwidth_font(psp_menu[top+i].label), y, color, *(psp_menu[top+i].value_int),0);
	}
      }
      if (disp_fonts && top+i!=sel)
	y+=8;
      else
	y+=get_font_height();
    }

    if(menu_items > rows){
      h = 257;
      xmax = 470; // reduce selection bar width so it doesn't overlay with scrollbar
      pgFillBoxHalfer(xmax+1,15,SCREEN_WIDTH,h,80);
      pgFillBox(xmax+1, h*top/menu_items + 15,	SCREEN_WIDTH, h*(top+rows)/menu_items, 0x1f<<10);
    } else {
      xmax = SCREEN_WIDTH;
    }
    // ADD_END

    /* DELETE_START
       pgPrint(1,0,TITLE_COL,"[NEOCDPSP " VERSION_STR "] - Menu",0);
       pgPrint(1,33,INFOBAR_COL,"\1 OK \2 Return game \5,\7 to select ,\6,\b to change value",0);


       if(menu_items > rows){
       h = 219;
       pgDrawFrame(445,25,446,248,0x1f<<10);
       pgFillBox(448, h*top/menu_items + 27,
       460, h*(top+rows)/menu_items + 27,0x1f<<10);
       }

       x=4; y=4;
       for(i=0; i<rows; i++){
       if((top+i) >= menu_items) break;
       if((top+i) == sel) 	color = SEL_COL;
       else color = FILE_COL;
       if (color==SEL_COL) pgPrintSel(x, y, color, psp_menu[top+i].label);
       else pgPrint(x, y, color, psp_menu[top+i].label,0);
       if (psp_menu[top+i].value_int) {
       if (psp_menu[top+i].values_list_label[0]){
       if (psp_menu[top+i].values_list_label[*(psp_menu[top+i].value_int)])
       pgPrint(x+strlen(psp_menu[top+i].label), y, color, psp_menu[top+i].values_list_label[*(psp_menu[top+i].value_int)],0);
       }else	pgPrintDecTrim(x+strlen(psp_menu[top+i].label), y, color, *(psp_menu[top+i].value_int),0);
       }

       y+=1;
       }
       DELETE_END */

    pgScreenFlipV();

    if(psp_ExitCheck()) {
      retval=-1;
      break;
    }
  } // for (;;)


  set_cpu_clock();
  init_autoframeskip();
  neogeo_adjust_cycles(neo4all_68k_cycles_idx,neo4all_z80_cycles_idx);
  neogeo_setregion();

  //since we cleared the vram, caches are corrupted
  blit_fix_resetcache();
  blit_spr_resetcache();

  if (!old_mp3_pause) MP3Pause(0);
  neogeo_soundmute=0;
  pgFillAllvram(0);
  pgScreenFrame(1,0);
  if (!neogeo_mp3_volume) cdda_stop();

  while (get_pad()) pgWaitV();
  return retval;
}

int save_settings(void){
  FILE *f;
  int l;
  //remove("ms0:/PSP/GAME/NEOCDPSP/neocdpsp.ini");
  sprintf(tmp_str,"%s%s",launchDir,"neocdpsp.ini");
  f = fopen(tmp_str,"wb");
  if (!f){
    ErrorMsg("cannot save settings");
    return -1;
  }
  l=(VERSION_MAJOR<<16)|VERSION_MINOR;
  fwrite(&l,1,4,f);
  fwrite(&neogeo_sound_enable,1,4,f);
  fwrite(&neogeo_frameskip,1,4,f);
  fwrite(&neogeo_blitter,1,4,f);
  fwrite(&psp_vsync,1,4,f);
  fwrite(&neogeo_showfps,1,4,f);
  fwrite(&neogeo_speedlimit,1,4,f);
  fwrite(&psp_cpuclock,1,4,f);
  fwrite(&neo4all_68k_cycles_idx,1,4,f);
  fwrite(&neo4all_z80_cycles_idx,1,4,f);
  fwrite(&neogeo_hardrender,1,4,f);
  fwrite(&neogeo_autofireA,1,4,f);
  fwrite(&neogeo_autofireB,1,4,f);
  fwrite(&neogeo_autofireC,1,4,f);
  fwrite(&neogeo_autofireD,1,4,f);
  fwrite(&neogeo_region,1,4,f);
  fwrite(&neogeo_mp3_volume,1,4,f);
  fwrite(&select_lock,1,4,f);
  fwrite(LastPath,1,sizeof(LastPath),f);
  fwrite(&neogeo_mp3_trackname,1,4,f);
  fwrite(default_font,1,sizeof(default_font),f);
  fwrite(&neogeo_mp3_errors,1,4,f);
  fwrite(&osd_background,1,4,f);
  fclose(f);
  return 0;
}

int load_settings(void){
  FILE *f;
  int version_file,l;
  sprintf(tmp_str,"%s%s",launchDir,"neocdpsp.ini");
  f = fopen(tmp_str,"rb");
  if (!f){
    debug_log("cannot load settings");
    return -1;
  }
  fread(&version_file,1,4,f);
  if (version_file>((VERSION_MAJOR<<16)|VERSION_MINOR)){
    debug_log("cannot load settings, too old version");
    fclose(f);
    return -2;
  }

#define READ_SETTING(a)				\
  if (fread(&l,1,4,f)==4) a=l;			\
  else {fclose(f);return -3;}

  READ_SETTING(neogeo_sound_enable);
  if (version_file<((0<<16)|(8))) { // Before version 0.8 there was mp3_enable
    READ_SETTING(l);
  }
  READ_SETTING(neogeo_frameskip)
    READ_SETTING(neogeo_blitter)
    READ_SETTING(psp_vsync)
    READ_SETTING(neogeo_showfps)
    READ_SETTING(neogeo_speedlimit)
    READ_SETTING(psp_cpuclock)
    READ_SETTING(neo4all_68k_cycles_idx)
    READ_SETTING(neo4all_z80_cycles_idx)
    READ_SETTING(neogeo_hardrender)
    READ_SETTING(neogeo_autofireA)
    READ_SETTING(neogeo_autofireB)
    READ_SETTING(neogeo_autofireC)
    READ_SETTING(neogeo_autofireD)
    READ_SETTING(neogeo_region)
    READ_SETTING(neogeo_mp3_volume)
    READ_SETTING(select_lock)
    fread(LastPath,1,sizeof(LastPath),f);
  READ_SETTING(neogeo_mp3_trackname)
    fread(default_font,1,sizeof(default_font),f);
  READ_SETTING(neogeo_mp3_errors)
  READ_SETTING(osd_background)
    fclose(f);
  return 0;
}
