#ifndef __PSP_H__
#define __PSP_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*#define malloc malloc_psp
#define free free_psp
#define calloc calloc_psp
#define realloc realloc_psp
*/

#define RELEASE
#define SNAPSHOT_ACTIVE

#include <pspkernel.h>
#include <pspdebug.h>
#include <pspctrl.h>
#include <stdio.h>
#include <stdlib.h>
//#include <unistd.h>
//#include <fcntl.h>
#include <string.h>
#include <math.h>

#include "pg.h"
#include "psplib.h"
//#include "malloc.h"

//#define memmove memmove_psp

void ErrorMsg(char *msg);

extern char launchDir[256];
extern char tmp_str[256];
  extern volatile int neogeo_soundmute;
  extern int neogeo_mp3_volume,psp_vsync,psp_cpuclock,neogeo_mp3_trackname,
    neogeo_mp3_errors,osd_background;

#define VRAM_ADDR	(0x04000000)

#define SCREEN_WIDTH	480
#define SCREEN_HEIGHT	272

#define POWER_CB_POWER		0x80000000 
#define POWER_CB_HOLDON		0x40000000 
#define POWER_CB_STANDBY	0x00080000 
#define POWER_CB_RESCOMP	0x00040000 
#define POWER_CB_RESUME		0x00020000 
#define POWER_CB_SUSPEND	0x00010000 
#define POWER_CB_EXT		0x00001000 
#define POWER_CB_BATLOW		0x00000100 
#define POWER_CB_BATTERY	0x00000080 
#define POWER_CB_BATTPOWER	0x0000007F 

#define MAX_PATH 256

  // These version major/minor are used to check the version of the ini file
  // if the version read in the ini file is > than the version in psp.h then
  // the read aborts. It's a very unlikely condition, but anyway...

#define VERSION_MAJOR 0
#define VERSION_MINOR 9

/* This changelog is mainly to remember the changes for the release.
 * See the web page for older changes.
 *
Changes for 0.8_U2 (by camiyu1) :
 - Added L trigger and R trigger function to configure key combination.
   (Default : old behaviour, and you can change it in menu)
   (If you want to enter menu, press L+select simultaneously and if you want to
    take snapshot, press R+select simultaneously - this replaces old "select
    lock)
 - Changed some default values : 
   CPU clock - 333, Screen - Zoom1, Frameskip - Auto, Region - USA

Radius :
 - Better centering of confirmation dialogs
 - Fixed pressing ltrigger in main menu, or rtrigger in font selector
 - Added title "Font selector"
 - Changed the tabs drawing
 - Fixed auto-repeat of keys in file browser

ZeLurker :
 - fixed the stupid incompatibility in sceGuScissor with psp sdks more recent
   than 27/12/2005. It should allow to compile neocdpsp with any sdk now.
   (thanks to camiyu1 for spotting the problem !)
 - Fix for the famous raster interrupt of the previous version : the 85%
   speed of art of fighting is now working, and there is a special case to
   make neo drift out to work correctly. This also fixes Samurai shodown 3.
   This created actually less bugs than what I feared.
 - Fixed the mp3 music not resuming in aero fighters 3 (very special case).
   Actually this is a genral fix for the mp3s so this might affect some other
   games too, but in the good way.
 - Replaced "Sound Enable" in the menu by "Sound volume"
 - Added a file cache, which avoids to load already loaded files (samurai
   spirits rpg tries 10% of the time to load files which are already loaded!)
 - Changed completely the way the neocd emulator loads its game files. The
   patch.prg file previously needed for "samurai spirits rpg" becomes useless.
   Just delete it if it's still in your neocdpsp directory ! This fixes at
   least the sound in samurai spirits rpg, and the music is now playing at
   the begining of "puzzled"
   This also allows to fix 90% of the upload area problems. The only game
   I could find which is still broken with this area is "neo geo cdspecial",
   and I made a special case for it. It's a potential for lots of new bugs,
   but apparently everyting is fine or better than before now !

 */

#define VERSION_STR "0.9"

int ExitCallback(int, int, void *);
void MP3Pause(int pause);
#ifndef RELEASE
void debug_log( const char* message );
#else
#define debug_log(message)
#endif
void StopSoundThread();
void InitSoundThread();
int PlayMP3(char *name);
void StopMP3();
int InitMP3Thread();
void StopMP3Thread();
void show_background(int fade);
int psp_ExitCheck();
void set_cpu_clock();
void print_center(char *msg);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __PSP_H__ */
