
#ifdef __cplusplus
extern "C" {
#endif
#ifndef __YMDELTAT_H_
#define __YMDELTAT_H_

#define YM_DELTAT_SHIFT    (16)


typedef void (*STATUS_CHANGE_HANDLER)(u8 which_chip, u8 status_bits);


/* DELTA-T (adpcm type B) struct */
typedef struct deltat_adpcm_state {     /* AT: rearranged and tigntened structure */
	u8	*memory;
	s32	*output_pointer;/* pointer of output pointers	*/
	s32	*pan;			/* pan : &output_pointer[pan]	*/
	double	freqbase;
#if 0
	double	write_time;		/* Y8950: 10 cycles of main clock; YM2608: 20 cycles of main clock */
	double	read_time;		/* Y8950: 8 cycles of main clock;  YM2608: 18 cycles of main clock */
#endif
	u32	memory_size;
	int	output_range;
	u32	now_addr;		/* current address		*/
	u32	now_step;		/* currect step			*/
	u32	step;			/* step					*/
	u32	start;			/* start address		*/
	u32	limit;			/* limit address		*/
	u32	end;			/* end address			*/
	u32	delta;			/* delta scale			*/
	s32	volume;			/* current volume		*/
	s32	acc;			/* shift Measurement value*/
	s32	adpcmd;			/* next Forecast		*/
	s32	adpcml;			/* current value		*/
	s32	prev_acc;		/* leveling value		*/
	u8	now_data;		/* current rom data		*/
	u8	CPU_data;		/* current data	from reg 08	*/
	u8	portstate;		/* port status			*/
	u8	control2;		/* control reg: SAMPLE, DA/AD, RAM TYPE (x8bit / x1bit), ROM/RAM */
	u8	portshift;		/* address bits shift-left:
							** 8 for YM2610,
							** 5 for Y8950 and YM2608 */

	u8	DRAMportshift;	/* address bits shift-right:
							** 0 for ROM and x8bit DRAMs,
							** 3 for x1 DRAMs */

	u8	memread;		/* needed for reading/writing external memory */

	/* handlers and parameters for the status flags support */
	STATUS_CHANGE_HANDLER	status_set_handler;
	STATUS_CHANGE_HANDLER	status_reset_handler;

	/* note that different chips have these flags on different
	** bits of the status register
	*/
	u8	status_change_which_chip;	/* this chip id */
	u8	status_change_EOS_bit;		/* 1 on End Of Sample (record/playback/cycle time of AD/DA converting has passed)*/
	u8	status_change_BRDY_bit;		/* 1 after recording 2 datas (2x4bits) or after reading/writing 1 data */
	u8	status_change_ZERO_bit;		/* 1 if silence lasts for more than 290 miliseconds on ADPCM recording */

	/* neither Y8950 nor YM2608 can generate IRQ when PCMBSY bit changes, so instead of above,
	** the statusflag gets ORed with PCM_BSY (below) (on each read of statusflag of Y8950 and YM2608)
	*/
	u8	PCM_BSY;		/* 1 when ADPCM is playing; Y8950/YM2608 only */

	u8	reg[16];		/* adpcm registers		*/
}YM_DELTAT;

/*void YM_DELTAT_BRDY_callback(YM_DELTAT *DELTAT);*/

u8 YM_DELTAT_ADPCM_Read(YM_DELTAT *DELTAT);
void YM_DELTAT_ADPCM_Write(YM_DELTAT *DELTAT,int r,int v);
void YM_DELTAT_ADPCM_Reset(YM_DELTAT *DELTAT,int pan);
void YM_DELTAT_ADPCM_CALC(YM_DELTAT *DELTAT);

void YM_DELTAT_postload(YM_DELTAT *DELTAT,u8 *regs);
void YM_DELTAT_savestate(const char *statename,int num,YM_DELTAT *DELTAT);

#endif

#ifdef __cplusplus
}
#endif
